@if (columnDisplay) {
  <div class="full-width full-height flex-row">
    @for (ancestorIsLast of depthArray; track ancestorIsLast; let i = $index) {
      <div
        class="flex-fixed-size full-height"
        [ngStyle]="getVerticalLineBackground(i, ancestorIsLast)"
        [style.width]="INDEX_BASE_WIDTH + 'px'"
      ></div>
    }
    <div
      class="flex-fixed-size full-height status-icon-container"
      [style.background-image]="lastLineBackground"
      [style.width]="INDEX_BASE_WIDTH + 'px'"
    >
      @if (!row.async && row.state !== 'leaf') {
        <div
          class="status-icon"
          [attr.data-test-row-toggle]="true"
          (click)="toggleRow($event)"
        >
          <i nz-icon [nzType]="stateIcon" nzTheme="outline"></i>
        </div>
      }
      @if (row.async && row.state !== 'leaf') {
        <div class="async-icon">
          <i
            class="current-workspace-main-color"
            nz-icon
            nzType="loading"
            nzTheme="outline"
          ></i>
        </div>
      }
    </div>
    @switch (templateName) {
      @case ('library') {
        <ng-container *ngTemplateOutlet="library"></ng-container>
      }
      @case ('simpleContainer') {
        <ng-container *ngTemplateOutlet="simpleContainer"></ng-container>
      }
      @case ('testCase') {
        <ng-container *ngTemplateOutlet="testCase"></ng-container>
      }
      @case ('requirementFolder') {
        <ng-container *ngTemplateOutlet="requirementFolder"></ng-container>
      }
      @case ('requirement') {
        <ng-container *ngTemplateOutlet="requirement"></ng-container>
      }
      @case ('highLevelRequirement') {
        <ng-container *ngTemplateOutlet="highLevelRequirement"></ng-container>
      }
      @case ('campaign') {
        <ng-container *ngTemplateOutlet="campaign"></ng-container>
      }
      @case ('sprint') {
        <ng-container *ngTemplateOutlet="sprint"></ng-container>
      }
      @case ('sprintGroup') {
        <ng-container *ngTemplateOutlet="sprintGroup"></ng-container>
      }
      @case ('iteration') {
        <ng-container *ngTemplateOutlet="iteration"></ng-container>
      }
      @case ('testSuite') {
        <ng-container *ngTemplateOutlet="testSuite"></ng-container>
      }
      @case ('taTest') {
        <ng-container *ngTemplateOutlet="taTest"></ng-container>
      }
      @case ('taProject') {
        <ng-container *ngTemplateOutlet="taProject"></ng-container>
      }
      @case ('customReportNode') {
        <ng-container *ngTemplateOutlet="customReportNode"></ng-container>
      }
      @case ('actionWord') {
        <ng-container *ngTemplateOutlet="actionWord"></ng-container>
      }
    }
  </div>
}

<ng-template #library>
  <div
    #openable
    class="library txt-ellipsis"
    [class.selected]="selected"
    [sqtmCoreSelectable]="row.id"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    (dblclick)="toggleRow($event)"
  >
    <i
      class="m-l-10 font-16-px"
      nz-icon
      [nzType]="libraryIcon"
      nzTheme="fill"
    ></i>
    <div
      class="m-l-10 m-r-15 current-workspace-main-color name"
      [ngClass]="getTreeNodeClasses()"
      nz-tooltip
      [sqtmCoreLabelTooltip]="nodeName"
      [nzTooltipPlacement]="'right'"
    >
      <span class="force-ltr-for-node-name">{{ nodeName }}</span>
    </div>
  </div>
</ng-template>

<ng-template #simpleContainer>
  <div
    #openable
    class="capsule container-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    [class.selected]="selected"
    (dblclick)="toggleRow($event)"
  >
    <i
      class="m-l-10 font-16-px"
      nz-icon
      [nzType]="SQTM_CORE_TREE_ICON_PREFIX + ':folder'"
    ></i>
    <div
      class="m-l-10 m-r-15 name"
      [ngClass]="getTreeNodeClasses()"
      nz-tooltip
      [sqtmCoreLabelTooltip]="nodeName"
      [nzTooltipPlacement]="'right'"
    >
      <span class="force-ltr-for-node-name">{{ nodeName }}</span>
    </div>
  </div>
</ng-template>

<ng-template #campaign>
  <div
    class="capsule container-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [class.selected]="selected"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    (dblclick)="toggleRow($event)"
  >
    <i
      class="m-l-10 font-16-px current-workspace-main-color"
      nz-icon
      [nzType]="SQTM_CORE_TREE_ICON_PREFIX + ':campaign'"
    ></i>
    <div
      class="m-l-10 m-r-15 name"
      [ngClass]="getTreeNodeClasses()"
      nz-tooltip
      [sqtmCoreLabelTooltip]="nodeName"
      [nzTooltipPlacement]="'right'"
    >
      <span class="force-ltr-for-node-name">{{ nodeName }}</span>
    </div>
  </div>
</ng-template>

<ng-template #sprint>
  <div
    class="external-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [class.selected]="selected"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    (dblclick)="toggleRow($event)"
  >
    <div
      class="full-height flex-fixed-size capsule-left-color-indicator"
      [style.background-color]="sprintBorderColor"
      nz-tooltip
      [nzTooltipTitle]="sprintStatus.i18nKey | translate"
      [attr.data-test-element-id]="'sprint-node-left-border'"
    ></div>
    <div
      class="full-height full-width txt-ellipsis inner-capsule"
      [class.selected]="selected"
    >
      <i
        class="m-l-10 font-16-px current-workspace-main-color"
        nz-icon
        [nzType]="SQTM_CORE_TREE_ICON_PREFIX + ':sprint'"
      ></i>
      @if (isSynchronized && hasRemoteSynchronizationId) {
        @if (isClosedSprint) {
          <i
            class="m-l-10 font-16-px"
            [attr.data-test-icon-id]="'remote-sprint-perimeter-status'"
            nz-tooltip
            [nzTooltipTitle]="'sqtm-core.generic.label.closed' | translate"
            nz-icon
            [nzType]="'sqtm-core-generic:locked'"
          ></i>
        } @else if (isDeletedSprint()) {
          <i
            class="m-l-10 font-16-px"
            [attr.data-test-icon-id]="'remote-sprint-perimeter-status'"
            nz-tooltip
            [nzTooltipTitle]="'sqtm-core.sprint.status.DELETED' | translate"
            nz-icon
            [nzType]="'sqtm-core-generic:delete'"
          ></i>
        } @else {
          <i
            class="m-l-10 font-16-px"
            [ngClass]="getLastSynchronizationStatusIconColor"
            [attr.data-test-icon-id]="'remote-sprint-perimeter-status'"
            nz-tooltip
            [nzTooltipTitle]="getRequirementSynchronizedStatusI18nKey"
            nz-icon
            [nzType]="'retweet'"
          ></i>
        }
      }
      <div
        class="m-l-10 m-r-15 sprint-name"
        [ngClass]="getTreeNodeClasses()"
        nz-tooltip
        [sqtmCoreLabelTooltip]="nodeName"
        [nzTooltipPlacement]="'right'"
      >
        <span class="force-ltr-for-node-name">{{ nodeName }}</span>
      </div>
    </div>
  </div>
</ng-template>

<ng-template #sprintGroup>
  <div
    class="capsule container-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [class.selected]="selected"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    (dblclick)="toggleRow($event)"
  >
    <i
      class="m-l-10 font-16-px current-workspace-main-color"
      nz-icon
      [nzType]="SQTM_CORE_TREE_ICON_PREFIX + ':sprint-group'"
    ></i>
    <div
      class="m-l-10 m-r-15 name"
      [ngClass]="getTreeNodeClasses()"
      nz-tooltip
      [sqtmCoreLabelTooltip]="nodeName"
      [nzTooltipPlacement]="'right'"
    >
      <span class="force-ltr-for-node-name">{{ nodeName }}</span>
    </div>
  </div>
</ng-template>

<ng-template #iteration>
  <div
    class="capsule container-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    [class.selected]="selected"
    (dblclick)="toggleRow($event)"
  >
    <i
      class="m-l-10 font-16-px current-workspace-main-color"
      nz-icon
      [nzType]="SQTM_CORE_TREE_ICON_PREFIX + ':iteration'"
    ></i>
    <div
      class="m-l-10 m-r-15 name"
      [ngClass]="getTreeNodeClasses()"
      nz-tooltip
      [sqtmCoreLabelTooltip]="nodeName"
      [nzTooltipPlacement]="'right'"
    >
      <span class="force-ltr-for-node-name">{{ nodeName }}</span>
    </div>
  </div>
</ng-template>

<ng-template #requirementFolder>
  <div
    #openable
    class="capsule container-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [class.selected]="selected"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    (dblclick)="toggleRow($event)"
  >
    <i
      class="m-l-10 font-16-px"
      nz-icon
      [nzType]="SQTM_CORE_TREE_ICON_PREFIX + ':folder'"
    ></i>
    @if (isSynchronized) {
      <i
        class="m-l-10 font-16-px"
        [ngClass]="getLastSynchronizationStatusIconColor"
        nz-tooltip
        [nzTooltipTitle]="getRequirementSynchronizedStatusI18nKey"
        [attr.data-test-icon-id]="'synchronization-status'"
        nz-icon
        [nzType]="'retweet'"
      ></i>
    }
    <div
      class="m-l-10 m-r-15 name"
      [ngClass]="getTreeNodeClasses()"
      nz-tooltip
      [sqtmCoreLabelTooltip]="nodeName"
      [nzTooltipPlacement]="'right'"
    >
      <span class="force-ltr-for-node-name">{{ nodeName }}</span>
    </div>
  </div>
</ng-template>

<ng-template #testCase>
  <div
    class="external-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [sqtmCoreSelectableDisabled]="!row.selectable"
  >
    <div
      class="full-height flex-fixed-size capsule-left-color-indicator"
      [style.background-color]="testCaseBorderColor"
      nz-tooltip
      [nzTooltipTitle]="testCaseImportance.i18nKey | translate"
    ></div>
    <div
      class="full-height full-width txt-ellipsis inner-capsule"
      [class.selected]="selected"
    >
      @if (mustShowInfoListItemIcon('TC_NATURE_ICON')) {
        <i
          class="m-l-10 font-16-px sqtm-core-infolist-icon"
          nz-icon
          [nzType]="getShowInfoListItemIcon('TC_NATURE_ICON')"
          nz-tooltip
          [nzTooltipTitle]="testCaseNatureLabel"
        ></i>
      } @else {
        <div class="m-l-10 flex-fixed-size" style="width: 14px"></div>
      }
      <i
        class="m-l-10 font-16-px"
        nz-icon
        [nzType]="testCaseStatusIcon"
        nzTheme="fill"
        nz-tooltip
        [nzTooltipTitle]="testCaseStatusTooltip"
        [style.color]="testCaseStatusColor"
      ></i>
      <div
        class="m-l-10 m-r-15 name"
        [ngClass]="getTreeNodeClasses()"
        [style.color]="testCaseNameColor"
        nz-tooltip
        [sqtmCoreLabelTooltip]="nodeName"
        [nzTooltipPlacement]="'right'"
      >
        <span class="force-ltr-for-node-name">{{ nodeName }}</span>
      </div>
    </div>
  </div>
</ng-template>

<ng-template #testSuite>
  <div
    class="external-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    (dblclick)="toggleRow($event)"
  >
    <div
      class="full-height flex-fixed-size capsule-left-color-indicator"
      [style.background-color]="testSuiteBorderColor"
      nz-tooltip
      [nzTooltipTitle]="testSuiteStatus.i18nKey | translate"
    ></div>
    <div
      class="full-height full-width txt-ellipsis inner-capsule"
      [class.selected]="selected"
    >
      <i
        class="m-l-10 font-16-px current-workspace-main-color"
        nz-icon
        [nzType]="SQTM_CORE_TREE_ICON_PREFIX + ':tests-suite'"
      ></i>
      <div
        class="m-l-10 m-r-15 name"
        [ngClass]="getTreeNodeClasses()"
        nz-tooltip
        [sqtmCoreLabelTooltip]="nodeName"
        [nzTooltipPlacement]="'right'"
      >
        <span class="force-ltr-for-node-name">{{ nodeName }}</span>
      </div>
    </div>
  </div>
</ng-template>

<ng-template #requirement>
  <div
    #openable
    class="external-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [sqtmCoreSelectableDisabled]="isRequirementUnselectable"
    (dblclick)="toggleRow($event)"
  >
    <div
      class="full-height flex-fixed-size capsule-left-color-indicator"
      [style.background-color]="requirementBorderColor"
      nz-tooltip
      [nzTooltipTitle]="requirementCriticality.i18nKey | translate"
    ></div>
    <div
      class="full-height full-width txt-ellipsis inner-capsule"
      [class.selected]="selected"
    >
      @if (mustShowInfoListItemIcon('REQ_CATEGORY_ICON')) {
        <i
          class="m-l-10 font-16-px"
          nz-icon
          [nzType]="getShowInfoListItemIcon('REQ_CATEGORY_ICON')"
          nz-tooltip
          [nzTooltipTitle]="reqCategoryLabel"
        ></i>
      } @else {
        <div class="m-l-10 flex-fixed-size" style="width: 14px"></div>
      }
      @if (isSynchronized && hasRemoteSynchronizationId) {
        <i
          class="m-l-10 font-16-px"
          [ngClass]="getRemoteReqPerimeterStatusIconColor()"
          [attr.data-test-icon-id]="'remote-req-perimeter-status'"
          nz-tooltip
          [nzTooltipTitle]="getRemoteReqPerimeterStatusI18nKey()"
          nz-icon
          [nzType]="'retweet'"
        ></i>
      }
      <i
        class="m-l-10 font-16-px"
        nz-icon
        [nzType]="requirementStatusIcon"
        nzTheme="fill"
        nz-tooltip
        [nzTooltipTitle]="requirementStatusTooltip"
        [style.color]="requirementStatusColor"
      ></i>
      <div
        class="m-l-10 m-r-15 name"
        [ngClass]="getTreeNodeClasses()"
        [class.synchronized]="isSynchronized"
        [class.requirement-unselectable]="isRequirementUnselectable"
        nz-tooltip
        [sqtmCoreLabelTooltip]="nodeName"
        [nzTooltipPlacement]="'right'"
      >
        <span class="force-ltr-for-node-name">{{ nodeName }}</span>
      </div>
    </div>
  </div>
</ng-template>
<ng-template #highLevelRequirement>
  <div
    #openable
    class="external-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [sqtmCoreSelectableDisabled]="isRequirementUnselectable"
    (dblclick)="toggleRow($event)"
  >
    <div
      class="full-height flex-fixed-size capsule-left-color-indicator"
      [style.background-color]="requirementBorderColor"
      nz-tooltip
      [nzTooltipTitle]="requirementCriticality.i18nKey | translate"
    ></div>
    <div
      class="full-height full-width txt-ellipsis inner-capsule"
      [class.selected]="selected"
    >
      @if (mustShowInfoListItemIcon('REQ_CATEGORY_ICON')) {
        <i
          class="m-l-10 font-16-px"
          nz-icon
          [nzType]="getShowInfoListItemIcon('REQ_CATEGORY_ICON')"
          nz-tooltip
          [nzTooltipTitle]="reqCategoryLabel"
        ></i>
      } @else {
        <div class="m-l-10 flex-fixed-size" style="width: 14px"></div>
      }
      @if (isSynchronized && hasRemoteSynchronizationId) {
        <i
          class="m-l-10 font-16-px"
          [ngClass]="getRemoteReqPerimeterStatusIconColor()"
          [attr.data-test-icon-id]="'remote-req-perimeter-status'"
          nz-tooltip
          [nzTooltipTitle]="getRemoteReqPerimeterStatusI18nKey()"
          nz-icon
          [nzType]="'retweet'"
        ></i>
      }
      <i
        class="m-l-10 font-16-px"
        nz-icon
        [nzType]="requirementStatusIcon"
        nzTheme="fill"
        nz-tooltip
        [nzTooltipTitle]="requirementStatusTooltip"
        [style.color]="requirementStatusColor"
      ></i>
      <div
        class="m-l-10 m-r-15 high-level-req-name"
        [ngClass]="getTreeNodeClasses()"
        [class.synchronized]="isSynchronized"
        [class.requirement-unselectable]="isRequirementUnselectable"
        nz-tooltip
        [sqtmCoreLabelTooltip]="nodeName"
        [nzTooltipPlacement]="'right'"
      >
        <span class="force-ltr-for-node-name">{{ nodeName }}</span>
      </div>
    </div>
  </div>
</ng-template>
<ng-template #taProject>
  <div
    class="library txt-ellipsis"
    [class.selected]="selected"
    [sqtmCoreSelectable]="row.id"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    (dblclick)="toggleRow($event)"
  >
    <i
      class="m-l-10 font-16-px"
      nz-icon
      nzType="sqtm-core-test-case:job"
      nzTheme="outline"
    ></i>
    <div
      class="m-l-10 m-r-15 current-workspace-main-color name"
      [ngClass]="getTreeNodeClasses()"
      nz-tooltip
      [sqtmCoreLabelTooltip]="nodeName"
      [nzTooltipPlacement]="'right'"
    >
      <span class="force-ltr-for-node-name">{{ nodeName }}</span>
    </div>
  </div>
</ng-template>
<ng-template #taTest>
  <div
    class="capsule container-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    [class.selected]="selected"
  >
    <i
      class="m-l-10 font-16-px"
      nz-icon
      nzType="sqtm-core-test-case:automation"
    ></i>
    <div
      class="m-l-10 m-r-15 name"
      [ngClass]="getTreeNodeClasses()"
      nz-tooltip
      [sqtmCoreLabelTooltip]="nodeName"
      [nzTooltipPlacement]="'right'"
    >
      <span class="force-ltr-for-node-name">{{ nodeName }}</span>
    </div>
  </div>
</ng-template>

<ng-template #actionWord>
  <div
    class="capsule container-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    [class.selected]="selected"
  >
    <i class="m-l-10 font-16-px" nz-icon nzType="sqtm-core-action:action"></i>
    <div
      class="m-l-10 m-r-15 name"
      [ngClass]="getTreeNodeClasses()"
      nz-tooltip
      [sqtmCoreLabelTooltip]="nodeName"
      [nzTooltipPlacement]="'right'"
    >
      <span class="force-ltr-for-node-name">{{ nodeName }}</span>
    </div>
  </div>
</ng-template>

<ng-template #testCaseStatusTooltip>
  <span>{{ testCaseStatus.i18nKey | translate }}</span
  ><br />
  <span>{{ testCaseTooltipCoverageMessage }}</span
  ><br />
  @if (mustShowTestCaseTooltipStepMessage) {
    <span>{{ testCaseTooltipStepMessage }}</span
    ><br />
  }
</ng-template>

<ng-template #requirementStatusTooltip>
  <span>{{ requirementStatus.i18nKey | translate }}</span
  ><br />
  <span>{{ requirementTooltipCoverageMessage }}</span
  ><br />
  <span>{{ requirementTooltipDescriptionMessage }}</span
  ><br />
</ng-template>

<ng-template #customReportNode>
  <div
    class="capsule container-capsule txt-ellipsis"
    [sqtmCoreSelectable]="row.id"
    [sqtmCoreSelectableDisabled]="!row.selectable"
    [class.selected]="selected"
  >
    <i
      class="m-l-10 font-16-px current-workspace-main-color"
      nz-icon
      [nzType]="getCustomReportIcon()"
    ></i>
    <div
      class="m-l-10 m-r-15 name"
      [ngClass]="getTreeNodeClasses()"
      nz-tooltip
      [sqtmCoreLabelTooltip]="nodeName"
      [nzTooltipPlacement]="'right'"
    >
      <span class="force-ltr-for-node-name">{{ nodeName }}</span>
    </div>
  </div>
</ng-template>
